{----------------------------------------------------}
{ Andreis LCARS-Components 1.2 for Delphi 2, (3), 4 }
{----------------------------------------------------}
{ Copyright (c) 1999 Andrei Scheibner                }
{ http://www.htwm.de/~ascheibn                       }
{ ascheibn@htwm.de                                   }
{----------------------------------------------------}
{These Components are Freeware. You can distribute them}
{altogether, you can improve them , but I would appreciate}
{it, if my name appears somewhere in your improvements.}

unit LCARSHCircle;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  THCircleAlign = (caTop, caRight, caBottom, caLeft);
  TLCARSHCircle = class(TGraphicControl)
  private
   FHCircleAlign : THCircleAlign;
   FBack : TBitmap;
   FBackColor : TColor;
   FHCircleColor : TColor;
   procedure SetHCircleAlign(value : THCircleAlign);
   procedure SetHCircleColor(value : TColor);
  protected
   procedure Paint; override;
  public
   constructor Create(AOwner : TComponent) ; override;
   destructor Destroy; override;
  published
   property Parent;
   property Width default 12;
   property Height default 25;
   property Hint;
   property ShowHint;
   property ParentShowHint;
   property Align;
   property HCircleColor : TColor read FHCircleColor
    write SetHCircleColor default clred;
   property Visible default true;
   property HCircleAlign : THCircleAlign read FHCircleAlign
    write SetHCircleAlign default caRight;
   property OnClick;
   property OnDblClick;
   property OnMouseDown;
   property OnMouseUp;
   property OnMouseMove;
   property OnDragDrop;
   property OnDragOver;
   property OnEndDrag;
  end;

implementation

constructor TLCARSHCircle.Create(AOwner : TComponent);
begin
 inherited Create(AOwner);
 Width := 12;
 Height := 25;
 HCircleColor := clred;
 HCircleAlign := caRight;
 Visible := true;
 Canvas.Brush.Style := bsClear;
 ControlStyle:=ControlStyle+[csOpaque];
 FBack := TBitmap.Create;
end;

destructor TLCARSHCircle.Destroy;
begin
 FBack.Free;
 inherited Destroy;
end;

procedure TLCARSHCircle.Paint;
var VisibleRect, BackRect : TRect;
begin
 FBack.Width := Width;
 FBack.Height := Height;
 if Parent <> nil then
  with Parent do
   FBackColor := Color;
 FBack.Canvas.Brush.Color := FBackColor;
 FBack.Canvas.Pen.Color := FBackColor;
 FBack.Canvas.Rectangle(0, 0, FBack.Width, FBack.Height);
 FBack.Canvas.FloodFill(FBack.Width div 2, FBack.Height div 2,
                        FBack.Canvas.Pixels[FBack.Width div 2, FBack.Height div 2],
                        fssurface);
 FBack.Canvas.Brush.Color := HCircleColor;
 FBack.Canvas.Pen.Color := HCircleColor;
 case FHCircleAlign of
  caTop :
   begin
    FBack.Canvas.MoveTo(0, 0);
    FBack.Canvas.LineTo(FBack.width, 0);
    FBack.Canvas.Arc(0, 0-FBack.height, FBack.width, FBack.height,
                     0, 0, FBack.width, 0);
   end;
  caRight :
   begin
    FBack.Canvas.MoveTo(FBack.width, 0);
    FBack.Canvas.LineTo(FBack.width, FBack.height);
    FBack.Canvas.Arc(0, 0, (FBack.width*2) , FBack.height,
                     FBack.width, 0, FBack.width, FBack.height);
   end;
  caBottom :
   begin
    FBack.Canvas.MoveTo(0, FBack.height);
    FBack.Canvas.LineTo(FBack.width, FBack.height);
    FBack.Canvas.Arc(0, 0, FBack.width, (FBack.height*2),
                     FBack.width, FBack.height, 0, FBack.height);
   end;
  caLeft:
   begin
    FBack.Canvas.MoveTo(0, 0);
    FBack.Canvas.LineTo(0, FBack.height);
    FBack.Canvas.Arc(0-FBack.width, 0, FBack.width ,FBack.height,
                     0, FBack.height, 0, 0);
   end;
 end;
 FBack.Canvas.FloodFill(FBack.Width div 2, FBack.Height div 2,
                        FBack.Canvas.Pixels[FBack.Width div 2, FBack.Height div 2],
                        fssurface);
 VisibleRect := Rect(0, 0, Width, Height);
 BackRect := Rect(0, 0, FBack.Width, Fback.Height);
 Canvas.CopyRect(VisibleRect, FBack.Canvas, BackRect);
end;

procedure TLCARSHCircle.SetHCircleAlign(value : THCircleAlign);
begin
 if FHCircleAlign <> value then
  begin
   FHCircleAlign := value;
   Repaint;
  end;
end;

procedure TLCARSHCircle.SetHCircleColor(value : TColor);
begin
 if FHCircleColor <> value then
  begin
   FHCircleColor := value;
   Repaint;
  end;
end;

end.
